Index: pjproject/trunk/pjlib/src/pjlib-test/ioq_tcp.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/ioq_tcp.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/ioq_tcp.c	(revision 1405)
@@ -51,4 +51,5 @@
                              callback_accept_status,
                              callback_connect_status;
+static unsigned		     callback_call_count;
 static pj_ioqueue_key_t     *callback_read_key,
                             *callback_write_key,
@@ -66,4 +67,5 @@
     callback_read_op = op_key;
     callback_read_size = bytes_read;
+    callback_call_count++;
 }
 
@@ -75,4 +77,5 @@
     callback_write_op = op_key;
     callback_write_size = bytes_written;
+    callback_call_count++;
 }
 
@@ -97,4 +100,5 @@
 	callback_accept_op = op_key;
 	callback_accept_status = status;
+	callback_call_count++;
     }
 }
@@ -104,4 +108,5 @@
     callback_connect_key = key;
     callback_connect_status = status;
+    callback_call_count++;
 }
 
@@ -169,5 +174,10 @@
     while (pending_op > 0) {
         timeout.sec = 1; timeout.msec = 0;
+#ifdef PJ_SYMBIAN
+	PJ_UNUSED_ARG(ioque);
+	status = pj_symbianos_poll(-1, 1000);
+#else
 	status = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	if (status > 0) {
             if (callback_read_size) {
@@ -198,5 +208,9 @@
     // Subsequent poll should yield zero too.
     timeout.sec = timeout.msec = 0;
+#ifdef PJ_SYMBIAN
+    status = pj_symbianos_poll(-1, 1);
+#else
     status = pj_ioqueue_poll(ioque, &timeout);
+#endif
     if (status != 0)
         return -173;
@@ -227,5 +241,5 @@
     char *send_buf, *recv_buf;
     pj_ioqueue_t *ioque = NULL;
-    pj_ioqueue_key_t *skey, *ckey0, *ckey1;
+    pj_ioqueue_key_t *skey=NULL, *ckey0=NULL, *ckey1=NULL;
     pj_ioqueue_op_key_t accept_op;
     int bufsize = BUF_MIN_SIZE;
@@ -244,5 +258,5 @@
 
     // Create server socket and client socket for connecting
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, &ssock);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &ssock);
     if (rc != PJ_SUCCESS) {
         app_perror("...error creating socket", rc);
@@ -250,5 +264,5 @@
     }
 
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, &csock1);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &csock1);
     if (rc != PJ_SUCCESS) {
         app_perror("...error creating socket", rc);
@@ -322,4 +336,5 @@
     callback_read_size = callback_write_size = 0;
     callback_accept_status = callback_connect_status = -2;
+    callback_call_count = 0;
 
     callback_read_key = callback_write_key = 
@@ -330,5 +345,11 @@
 	pj_time_val timeout = {1, 0};
 
-	status=pj_ioqueue_poll(ioque, &timeout);
+#ifdef PJ_SYMBIAN
+	callback_call_count = 0;
+	pj_symbianos_poll(-1, 1000);
+	status = callback_call_count;
+#else
+	status = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	if (status > 0) {
             if (callback_accept_status != -2) {
@@ -374,5 +395,9 @@
     if (pending_op == 0) {
         pj_time_val timeout = {1, 0};
+#ifdef PJ_SYMBIAN
+	status = pj_symbianos_poll(-1, 1000);
+#else
         status = pj_ioqueue_poll(ioque, &timeout);
+#endif
         if (status != 0) {
             status=-60; goto on_error;
@@ -408,10 +433,19 @@
 
 on_error:
-    if (ssock != PJ_INVALID_SOCKET)
+    if (skey != NULL)
+    	pj_ioqueue_unregister(skey);
+    else if (ssock != PJ_INVALID_SOCKET)
 	pj_sock_close(ssock);
-    if (csock1 != PJ_INVALID_SOCKET)
+    
+    if (ckey1 != NULL)
+    	pj_ioqueue_unregister(ckey1);
+    else if (csock1 != PJ_INVALID_SOCKET)
 	pj_sock_close(csock1);
-    if (csock0 != PJ_INVALID_SOCKET)
+    
+    if (ckey0 != NULL)
+    	pj_ioqueue_unregister(ckey0);
+    else if (csock0 != PJ_INVALID_SOCKET)
 	pj_sock_close(csock0);
+    
     if (ioque != NULL)
 	pj_ioqueue_destroy(ioque);
@@ -427,9 +461,9 @@
 static int compliance_test_1(void)
 {
-    pj_sock_t csock1=-1;
+    pj_sock_t csock1=PJ_INVALID_SOCKET;
     pj_sockaddr_in addr;
     pj_pool_t *pool = NULL;
     pj_ioqueue_t *ioque = NULL;
-    pj_ioqueue_key_t *ckey1;
+    pj_ioqueue_key_t *ckey1 = NULL;
     pj_ssize_t status = -1;
     int pending_op = 0;
@@ -447,5 +481,5 @@
 
     // Create client socket
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, &csock1);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &csock1);
     if (rc != PJ_SUCCESS) {
         app_perror("...ERROR in pj_sock_socket()", rc);
@@ -484,5 +518,11 @@
 	pj_time_val timeout = {1, 0};
 
-	status=pj_ioqueue_poll(ioque, &timeout);
+#ifdef PJ_SYMBIAN
+	callback_call_count = 0;
+	pj_symbianos_poll(-1, 1000);
+	status = callback_call_count;
+#else
+	status = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	if (status > 0) {
             if (callback_connect_key==ckey1) {
@@ -513,5 +553,9 @@
     if (pending_op == 0) {
         pj_time_val timeout = {1, 0};
+#ifdef PJ_SYMBIAN
+	status = pj_symbianos_poll(-1, 1000);
+#else
         status = pj_ioqueue_poll(ioque, &timeout);
+#endif
         if (status != 0) {
             status=-60; goto on_error;
@@ -523,6 +567,9 @@
 
 on_error:
-    if (csock1 != PJ_INVALID_SOCKET)
+    if (ckey1 != NULL)
+    	pj_ioqueue_unregister(ckey1);
+    else if (csock1 != PJ_INVALID_SOCKET)
 	pj_sock_close(csock1);
+    
     if (ioque != NULL)
 	pj_ioqueue_destroy(ioque);
@@ -577,4 +624,17 @@
     pj_status_t rc;
 
+    listener.sock = PJ_INVALID_SOCKET;
+    listener.key = NULL;
+    
+    for (i=0; i<MAX_PAIR; ++i) {
+    	server[i].sock = PJ_INVALID_SOCKET;
+    	server[i].key = NULL;
+    }
+    
+    for (i=0; i<MAX_PAIR; ++i) {
+    	client[i].sock = PJ_INVALID_SOCKET;
+    	client[i].key = NULL;	
+    }
+    
     // Create pool.
     pool = pj_pool_create(mem, NULL, POOL_SIZE, 4000, NULL);
@@ -594,5 +654,5 @@
 
     // Create listener socket
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, &listener.sock);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &listener.sock);
     if (rc != PJ_SUCCESS) {
         app_perror("...error creating socket", rc);
@@ -636,5 +696,5 @@
 	// Client connect and server accept.
 	for (i=0; i<MAX_PAIR; ++i) {
-	    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_STREAM, 0, &client[i].sock);
+	    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_STREAM(), 0, &client[i].sock);
 	    if (rc != PJ_SUCCESS) {
 		app_perror("...error creating socket", rc);
@@ -684,5 +744,9 @@
 	    pj_time_val timeout = {1, 0};
 
-	    status=pj_ioqueue_poll(ioque, &timeout);
+#ifdef PJ_SYMBIAN
+	    status = pj_symbianos_poll(-1, 1000);
+#else
+	    status = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	    if (status > 0) {
 		if (status > pending_op) {
@@ -705,5 +769,9 @@
 	if (pending_op == 0) {
 	    pj_time_val timeout = {1, 0};
+#ifdef PJ_SYMBIAN
+	    status = pj_symbianos_poll(-1, 1000);
+#else
 	    status = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	    if (status != 0) {
 		status=-120; goto on_error;
@@ -720,5 +788,5 @@
 
 	    // Check addresses
-	    if (server[i].local_addr.sin_family != PJ_AF_INET ||
+	    if (server[i].local_addr.sin_family != pj_AF_INET() ||
 		server[i].local_addr.sin_addr.s_addr == 0 ||
 		server[i].local_addr.sin_port == 0)
@@ -729,5 +797,5 @@
 	    }
 
-	    if (server[i].rem_addr.sin_family != PJ_AF_INET ||
+	    if (server[i].rem_addr.sin_family != pj_AF_INET() ||
 		server[i].rem_addr.sin_addr.s_addr == 0 ||
 		server[i].rem_addr.sin_port == 0)
Index: pjproject/trunk/pjlib/src/pjlib-test/ioq_udp.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/ioq_udp.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/ioq_udp.c	(revision 1405)
@@ -134,5 +134,5 @@
     char *send_buf, *recv_buf;
     pj_ioqueue_t *ioque = NULL;
-    pj_ioqueue_key_t *skey, *ckey;
+    pj_ioqueue_key_t *skey = NULL, *ckey = NULL;
     pj_ioqueue_op_key_t read_op, write_op;
     int bufsize = BUF_MIN_SIZE;
@@ -153,7 +153,7 @@
     // Allocate sockets for sending and receiving.
     TRACE_("creating sockets...");
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &ssock);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &ssock);
     if (rc==PJ_SUCCESS)
-        rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &csock);
+        rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &csock);
     else
         csock = PJ_INVALID_SOCKET;
@@ -166,5 +166,5 @@
     TRACE_("bind socket...");
     pj_bzero(&addr, sizeof(addr));
-    addr.sin_family = PJ_AF_INET;
+    addr.sin_family = pj_AF_INET();
     addr.sin_port = pj_htons(PORT);
     if (pj_sock_bind(ssock, &addr, sizeof(addr))) {
@@ -259,5 +259,9 @@
 
 	TRACE_("poll...");
+#ifdef PJ_SYMBIAN
+	rc = pj_symbianos_poll(-1, 5000);
+#else
 	rc = pj_ioqueue_poll(ioque, &timeout);
+#endif
 
 	if (rc == 0) {
@@ -286,5 +290,5 @@
 		status=-68; goto on_error;
 	    }
-	    if (addr.sin_family != PJ_AF_INET) {
+	    if (addr.sin_family != pj_AF_INET()) {
 		status=-69; goto on_error;
 	    }
@@ -313,8 +317,14 @@
 
 on_error:
-    if (ssock)
+    if (skey)
+    	pj_ioqueue_unregister(skey);
+    else if (ssock != -1)
 	pj_sock_close(ssock);
-    if (csock)
+    
+    if (ckey)
+    	pj_ioqueue_unregister(ckey);
+    else if (csock != -1)
 	pj_sock_close(csock);
+    
     if (ioque != NULL)
 	pj_ioqueue_destroy(ioque);
@@ -373,5 +383,5 @@
 
     /* Create sender socket */
-    status = app_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, SPORT, &ssock);
+    status = app_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, SPORT, &ssock);
     if (status != PJ_SUCCESS) {
 	app_perror("Error initializing socket", status);
@@ -380,5 +390,5 @@
 
     /* Create receiver socket. */
-    status = app_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, RPORT, &rsock);
+    status = app_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, RPORT, &rsock);
     if (status != PJ_SUCCESS) {
 	app_perror("Error initializing socket", status);
@@ -436,5 +446,9 @@
     /* Check if packet is received. */
     timeout.sec = 1; timeout.msec = 0;
+#ifdef PJ_SYMBIAN
+    pj_symbianos_poll(-1, 1000);
+#else
     pj_ioqueue_poll(ioqueue, &timeout);
+#endif
 
     if (packet_cnt != 1) {
@@ -470,6 +484,10 @@
 
     /* Poll ioqueue. */
+#ifdef PJ_SYMBIAN
+    pj_symbianos_poll(-1, 1000);
+#else
     timeout.sec = 1; timeout.msec = 0;
     pj_ioqueue_poll(ioqueue, &timeout);
+#endif
 
     /* Must NOT receive any packets after socket is closed! */
@@ -525,5 +543,5 @@
     for (count=0; count<MAX; ++count) {
 	sock[count] = PJ_INVALID_SOCKET;
-	rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock[count]);
+	rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &sock[count]);
 	if (rc != PJ_SUCCESS || sock[count] == PJ_INVALID_SOCKET) {
 	    PJ_LOG(3,(THIS_FILE, "....unable to create %d-th socket, rc=%d", 
@@ -592,5 +610,5 @@
     char *send_buf, *recv_buf;
     pj_ioqueue_t *ioque = NULL;
-    pj_ioqueue_key_t *skey, *ckey, *key;
+    pj_ioqueue_key_t *skey, *ckey, *keys[SOCK_INACTIVE_MAX+2];
     pj_timestamp t1, t2, t_elapsed;
     int rc=0, i;    /* i must be signed */
@@ -608,7 +626,7 @@
 
     // Allocate sockets for sending and receiving.
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &ssock);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &ssock);
     if (rc == PJ_SUCCESS) {
-        rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &csock);
+        rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &csock);
     } else
         csock = PJ_INVALID_SOCKET;
@@ -620,5 +638,5 @@
     // Bind server socket.
     pj_bzero(&addr, sizeof(addr));
-    addr.sin_family = PJ_AF_INET;
+    addr.sin_family = pj_AF_INET();
     addr.sin_port = pj_htons(PORT);
     if (pj_sock_bind(ssock, &addr, sizeof(addr)))
@@ -641,9 +659,9 @@
                               inactive_sock_count*sizeof(pj_ioqueue_op_key_t));
     pj_bzero(&addr, sizeof(addr));
-    addr.sin_family = PJ_AF_INET;
+    addr.sin_family = pj_AF_INET();
     for (i=0; i<inactive_sock_count; ++i) {
         pj_ssize_t bytes;
 
-	rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &inactive_sock[i]);
+	rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &inactive_sock[i]);
 	if (rc != PJ_SUCCESS || inactive_sock[i] < 0) {
 	    app_perror("...error: pj_sock_socket()", rc);
@@ -657,5 +675,5 @@
 	}
 	rc = pj_ioqueue_register_sock(pool, ioque, inactive_sock[i], 
-			              NULL, &test_cb, &key);
+			              NULL, &test_cb, &keys[i]);
 	if (rc != PJ_SUCCESS) {
 	    pj_sock_close(inactive_sock[i]);
@@ -666,5 +684,5 @@
 	}
         bytes = bufsize;
-	rc = pj_ioqueue_recv(key, &inactive_read_op[i], recv_buf, &bytes, 0);
+	rc = pj_ioqueue_recv(keys[i], &inactive_read_op[i], recv_buf, &bytes, 0);
 	if (rc != PJ_EPENDING) {
 	    pj_sock_close(inactive_sock[i]);
@@ -736,5 +754,9 @@
 	do {
 	    pj_time_val timeout = { 1, 0 };
+#ifdef PJ_SYMBIAN
+	    rc = pj_symbianos_poll(-1, 1000);
+#else
 	    rc = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	    TRACE__((THIS_FILE, "     poll rc=%d", rc));
 	} while (rc >= 0 && callback_read_key != skey);
@@ -761,5 +783,9 @@
 	do {
 	    pj_time_val timeout = { 0, 10 };
+#ifdef PJ_SYMBIAN
+	    rc = pj_symbianos_poll(-1, 100);
+#else	    
 	    rc = pj_ioqueue_poll(ioque, &timeout);
+#endif
 	} while (rc>0);
 
@@ -785,9 +811,9 @@
     // Cleaning up.
     for (i=inactive_sock_count-1; i>=0; --i) {
-	pj_sock_close(inactive_sock[i]);
-    }
-
-    pj_sock_close(ssock);
-    pj_sock_close(csock);
+	pj_ioqueue_unregister(keys[i]);
+    }
+
+    pj_ioqueue_unregister(skey);
+    pj_ioqueue_unregister(ckey);
 
 
Index: pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/ioq_unreg.c	(revision 1405)
@@ -160,5 +160,5 @@
      */
     if (other_socket) {
-	status = app_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, 56127, &osd.sock);
+	status = app_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, 56127, &osd.sock);
 	if (status != PJ_SUCCESS) {
 	    app_perror("Error creating other socket", status);
@@ -201,5 +201,5 @@
 
     /* Create pair of client/server sockets */
-    status = app_socketpair(PJ_AF_INET, PJ_SOCK_DGRAM, 0, 
+    status = app_socketpair(pj_AF_INET(), pj_SOCK_DGRAM(), 0, 
 			    &sock_data.sock, &sock_data.csock);
     if (status != PJ_SUCCESS) {
Index: pjproject/trunk/pjlib/src/pjlib-test/main.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 1405)
@@ -82,7 +82,7 @@
             
             if (pj_stricmp2(&type, "tcp")==0)
-                param_echo_sock_type = PJ_SOCK_STREAM;
+                param_echo_sock_type = pj_SOCK_STREAM();
             else if (pj_stricmp2(&type, "udp")==0)
-                param_echo_sock_type = PJ_SOCK_DGRAM;
+                param_echo_sock_type = pj_SOCK_DGRAM();
             else {
                 PJ_LOG(3,("", "error: unknown socket type %s", type.ptr));
Index: pjproject/trunk/pjlib/src/pjlib-test/select.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/select.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/select.c	(revision 1405)
@@ -113,10 +113,10 @@
     
     // Create two UDP sockets.
-    rc = pj_sock_socket( PJ_AF_INET, PJ_SOCK_DGRAM, 0, &udp1);
+    rc = pj_sock_socket( pj_AF_INET(), pj_SOCK_DGRAM(), 0, &udp1);
     if (rc != PJ_SUCCESS) {
         app_perror("...error: unable to create socket", rc);
 	status=-10; goto on_return;
     }
-    rc = pj_sock_socket( PJ_AF_INET, PJ_SOCK_DGRAM, 0, &udp2);
+    rc = pj_sock_socket( pj_AF_INET(), pj_SOCK_DGRAM(), 0, &udp2);
     if (udp2 == PJ_INVALID_SOCKET) {
         app_perror("...error: unable to create socket", rc);
@@ -126,5 +126,5 @@
     // Bind one of the UDP socket.
     pj_bzero(&udp_addr, sizeof(udp_addr));
-    udp_addr.sin_family = PJ_AF_INET;
+    udp_addr.sin_family = pj_AF_INET();
     udp_addr.sin_port = UDP_PORT;
     udp_addr.sin_addr = pj_inet_addr(pj_cstr(&s, "127.0.0.1"));
Index: pjproject/trunk/pjlib/src/pjlib-test/sock.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/sock.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/sock.c	(revision 1405)
@@ -78,10 +78,5 @@
     pj_sockaddr_in addr2;
     const pj_str_t *hostname;
-#if defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
-    /* Symbian IP address is saved in host order */
-    unsigned char A[] = {1, 0, 0, 127};
-#else
-    unsigned char A[] = {127, 0, 0, 1};
-#endif
+    const unsigned char A[] = {127, 0, 0, 1};
 
     PJ_LOG(3,("test", "...format_test()"));
@@ -137,6 +132,6 @@
     pj_status_t rc = PJ_SUCCESS;
 
-    types[0] = PJ_SOCK_STREAM;
-    types[1] = PJ_SOCK_DGRAM;
+    types[0] = pj_SOCK_STREAM();
+    types[1] = pj_SOCK_DGRAM();
 
     PJ_LOG(3,("test", "...simple_sock_test()"));
@@ -144,7 +139,7 @@
     for (i=0; i<(int)(sizeof(types)/sizeof(types[0])); ++i) {
 	
-	rc = pj_sock_socket(PJ_AF_INET, types[i], 0, &sock);
+	rc = pj_sock_socket(pj_AF_INET(), types[i], 0, &sock);
 	if (rc != PJ_SUCCESS) {
-	    app_perror("...error: unable to create socket type %d", rc);
+	    app_perror("...error: unable to create socket", rc);
 	    break;
 	} else {
@@ -238,5 +233,5 @@
             }
 	    if (received != DATA_LEN-total_received) {
-                if (sock_type != PJ_SOCK_STREAM) {
+                if (sock_type != pj_SOCK_STREAM()) {
 	            PJ_LOG(3,("", "...error: expecting %u bytes, got %u bytes",
                               DATA_LEN-total_received, received));
@@ -296,5 +291,5 @@
         }
 	if (received != BIG_DATA_LEN-total_received) {
-            if (sock_type != PJ_SOCK_STREAM) {
+            if (sock_type != pj_SOCK_STREAM()) {
 	        PJ_LOG(3,("", "...error: expecting %u bytes, got %u bytes",
                           BIG_DATA_LEN-total_received, received));
@@ -326,5 +321,5 @@
     PJ_LOG(3,("test", "...udp_test()"));
 
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &ss);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &ss);
     if (rc != 0) {
 	app_perror("...error: unable to create socket", rc);
@@ -332,5 +327,5 @@
     }
 
-    rc = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &cs);
+    rc = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &cs);
     if (rc != 0)
 	return -110;
@@ -338,5 +333,5 @@
     /* Bind server socket. */
     pj_bzero(&dstaddr, sizeof(dstaddr));
-    dstaddr.sin_family = PJ_AF_INET;
+    dstaddr.sin_family = pj_AF_INET();
     dstaddr.sin_port = pj_htons(UDP_PORT);
     dstaddr.sin_addr = pj_inet_addr(pj_cstr(&s, ADDRESS));
@@ -349,5 +344,5 @@
     /* Bind client socket. */
     pj_bzero(&srcaddr, sizeof(srcaddr));
-    srcaddr.sin_family = PJ_AF_INET;
+    srcaddr.sin_family = pj_AF_INET();
     srcaddr.sin_port = pj_htons(UDP_PORT-1);
     srcaddr.sin_addr = pj_inet_addr(pj_cstr(&s, ADDRESS));
@@ -359,5 +354,5 @@
 	    
     /* Test send/recv, with sendto */
-    rc = send_recv_test(PJ_SOCK_DGRAM, ss, cs, &dstaddr, NULL, 
+    rc = send_recv_test(pj_SOCK_DGRAM(), ss, cs, &dstaddr, NULL, 
                         sizeof(dstaddr));
     if (rc != 0)
@@ -365,5 +360,5 @@
 
     /* Test send/recv, with sendto and recvfrom */
-    rc = send_recv_test(PJ_SOCK_DGRAM, ss, cs, &dstaddr, 
+    rc = send_recv_test(pj_SOCK_DGRAM(), ss, cs, &dstaddr, 
                         &srcaddr, sizeof(dstaddr));
     if (rc != 0)
@@ -383,10 +378,10 @@
 
     /* Test send/recv with send() */
-    rc = send_recv_test(PJ_SOCK_DGRAM, ss, cs, NULL, NULL, 0);
+    rc = send_recv_test(pj_SOCK_DGRAM(), ss, cs, NULL, NULL, 0);
     if (rc != 0)
 	goto on_error;
 
     /* Test send/recv with send() and recvfrom */
-    rc = send_recv_test(PJ_SOCK_DGRAM, ss, cs, NULL, &srcaddr, 
+    rc = send_recv_test(pj_SOCK_DGRAM(), ss, cs, NULL, &srcaddr, 
                         sizeof(srcaddr));
     if (rc != 0)
@@ -421,5 +416,5 @@
     PJ_LOG(3,("test", "...tcp_test()"));
 
-    rc = app_socketpair(PJ_AF_INET, PJ_SOCK_STREAM, 0, &ss, &cs);
+    rc = app_socketpair(pj_AF_INET(), pj_SOCK_STREAM(), 0, &ss, &cs);
     if (rc != PJ_SUCCESS) {
         app_perror("...error: app_socketpair():", rc);
@@ -428,5 +423,5 @@
 
     /* Test send/recv with send() and recv() */
-    retval = send_recv_test(PJ_SOCK_STREAM, ss, cs, NULL, NULL, 0);
+    retval = send_recv_test(pj_SOCK_STREAM(), ss, cs, NULL, NULL, 0);
 
     rc = pj_sock_close(cs);
Index: pjproject/trunk/pjlib/src/pjlib-test/sock_perf.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/sock_perf.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/sock_perf.c	(revision 1405)
@@ -63,5 +63,5 @@
 
     /* Create producer-consumer pair. */
-    rc = app_socketpair(PJ_AF_INET, sock_type, 0, &consumer, &producer);
+    rc = app_socketpair(pj_AF_INET(), sock_type, 0, &consumer, &producer);
     if (rc != PJ_SUCCESS) {
         app_perror("...error: create socket pair", rc);
@@ -106,5 +106,5 @@
             }
 	    if ((pj_size_t)part_received != buf_size-received) {
-                if (sock_type != PJ_SOCK_STREAM) {
+                if (sock_type != pj_SOCK_STREAM()) {
 	            PJ_LOG(3,("", "...error: expecting %u bytes, got %u bytes",
                               buf_size-received, part_received));
@@ -166,5 +166,5 @@
 #if !defined(PJ_SYMBIAN) || PJ_SYMBIAN==0
     /* Benchmarking UDP */
-    rc = sock_producer_consumer(PJ_SOCK_DGRAM, 512, LOOP, &bandwidth);
+    rc = sock_producer_consumer(pj_SOCK_DGRAM(), 512, LOOP, &bandwidth);
     if (rc != 0) return rc;
     PJ_LOG(3,("", "....bandwidth UDP = %d KB/s", bandwidth));
@@ -172,5 +172,5 @@
 
     /* Benchmarking TCP */
-    rc = sock_producer_consumer(PJ_SOCK_STREAM, 512, LOOP, &bandwidth);
+    rc = sock_producer_consumer(pj_SOCK_STREAM(), 512, LOOP, &bandwidth);
     if (rc != 0) return rc;
     PJ_LOG(3,("", "....bandwidth TCP = %d KB/s", bandwidth));
Index: pjproject/trunk/pjlib/src/pjlib-test/test.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/test.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/test.c	(revision 1405)
@@ -65,5 +65,5 @@
     
     //pj_dump_config();
-    pj_caching_pool_init( &caching_pool, &pj_pool_factory_default_policy, 0 );
+    pj_caching_pool_init( &caching_pool, NULL, 0 );
 
 #if INCLUDE_ERRNO_TEST
@@ -166,5 +166,5 @@
 #elif INCLUDE_ECHO_CLIENT
     if (param_echo_sock_type == 0)
-        param_echo_sock_type = PJ_SOCK_DGRAM;
+        param_echo_sock_type = pj_SOCK_DGRAM();
 
     echo_client( param_echo_sock_type, 
@@ -192,7 +192,12 @@
 }
 
+#include <pj/sock.h>
+
 int test_main(void)
 {
+    int i;
     PJ_USE_EXCEPTION;
+
+    i = pj_AF_INET();
 
     PJ_TRY {
Index: pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 1405)
@@ -177,5 +177,5 @@
     }
 
-    rc = app_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, 
+    rc = app_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, 
                     ECHO_SERVER_START_PORT, &sock);
     if (rc != PJ_SUCCESS) {
Index: pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 1405)
@@ -78,5 +78,5 @@
     }
 
-    rc = app_socket(PJ_AF_INET, PJ_SOCK_DGRAM,0, ECHO_SERVER_START_PORT, &sock);
+    rc = app_socket(pj_AF_INET(), pj_SOCK_DGRAM(),0, ECHO_SERVER_START_PORT, &sock);
     if (rc != PJ_SUCCESS) {
         app_perror("...socket error", rc);
Index: pjproject/trunk/pjlib/src/pjlib-test/util.c
===================================================================
--- pjproject/trunk/pjlib/src/pjlib-test/util.c	(revision 1404)
+++ pjproject/trunk/pjlib/src/pjlib-test/util.c	(revision 1405)
@@ -54,5 +54,5 @@
     
 #if PJ_HAS_TCP
-    if (type == PJ_SOCK_STREAM) {
+    if (type == pj_SOCK_STREAM()) {
         rc = pj_sock_listen(sock, 5);
         if (rc != PJ_SUCCESS)
@@ -87,5 +87,5 @@
     /* Retry bind */
     pj_bzero(&addr, sizeof(addr));
-    addr.sin_family = PJ_AF_INET;
+    addr.sin_family = pj_AF_INET();
     for (i=0; i<5; ++i) {
         addr.sin_port = pj_htons(port++);
@@ -100,5 +100,5 @@
     /* For TCP, listen the socket. */
 #if PJ_HAS_TCP
-    if (type == PJ_SOCK_STREAM) {
+    if (type == pj_SOCK_STREAM()) {
         rc = pj_sock_listen(sock[SERVER], PJ_SOMAXCONN);
         if (rc != PJ_SUCCESS)
@@ -115,5 +115,5 @@
     /* For TCP, must accept(), and get the new socket. */
 #if PJ_HAS_TCP
-    if (type == PJ_SOCK_STREAM) {
+    if (type == pj_SOCK_STREAM()) {
         pj_sock_t newserver;
 
Index: pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1404)
+++ pjproject/trunk/pjmedia/src/pjmedia/transport_udp.c	(revision 1405)
@@ -163,5 +163,5 @@
 
     /* Create RTP socket */
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &si.rtp_sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &si.rtp_sock);
     if (status != PJ_SUCCESS)
 	goto on_error;
@@ -176,5 +176,5 @@
 
     /* Create RTCP socket */
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &si.rtcp_sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &si.rtcp_sock);
     if (status != PJ_SUCCESS)
 	goto on_error;
Index: pjproject/trunk/pjmedia/src/test/audio_tool.c
===================================================================
--- pjproject/trunk/pjmedia/src/test/audio_tool.c	(revision 1404)
+++ pjproject/trunk/pjmedia/src/test/audio_tool.c	(revision 1405)
@@ -265,5 +265,5 @@
 
     pj_bzero(&skinfo, sizeof(skinfo));
-    skinfo.rtp_sock = skinfo.rtcp_sock = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, 0);
+    skinfo.rtp_sock = skinfo.rtcp_sock = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, 0);
     if (skinfo.rtp_sock == PJ_INVALID_SOCKET) {
 	PJ_LOG(1,(THIS_FILE, "Unable to create socket"));
Index: pjproject/trunk/pjnath/src/pjnath/ice_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1405)
@@ -727,5 +727,5 @@
     pj_ansi_strcpy(laddr, pj_inet_ntoa(lcand->addr.ipv4.sin_addr));
 
-    if (lcand->addr.addr.sa_family == PJ_AF_INET) {
+    if (lcand->addr.addr.sa_family == pj_AF_INET()) {
 	len = pj_ansi_snprintf(buffer, bufsize,
 			       "%d: [%d] %s:%d-->%s:%d",
@@ -835,8 +835,8 @@
 	return SOCKADDR_NOT_EQUAL;
 
-    if (a1->addr.sa_family == PJ_AF_INET) {
+    if (a1->addr.sa_family == pj_AF_INET()) {
 	return !(a1->ipv4.sin_addr.s_addr == a2->ipv4.sin_addr.s_addr &&
 		 a1->ipv4.sin_port == a2->ipv4.sin_port);
-    } else if (a1->addr.sa_family == PJ_AF_INET6) {
+    } else if (a1->addr.sa_family == pj_AF_INET6()) {
 	return pj_memcmp(&a1->ipv6, &a2->ipv6, sizeof(a1->ipv6));
     } else {
Index: pjproject/trunk/pjnath/src/pjnath/ice_strans.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 1405)
@@ -286,5 +286,5 @@
 
     /* Create socket */
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &comp->sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &comp->sock);
     if (status != PJ_SUCCESS)
 	return status;
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg.c	(revision 1405)
@@ -770,5 +770,5 @@
 
     /* Family (IPv4 only for now) */
-    PJ_ASSERT_RETURN(ca->sockaddr.addr.sa_family == PJ_AF_INET, PJ_EINVAL);
+    PJ_ASSERT_RETURN(ca->sockaddr.addr.sa_family == pj_AF_INET(), PJ_EINVAL);
     *buf++ = 1;
 
Index: pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjnath/stun_msg_dump.c	(revision 1405)
@@ -84,5 +84,5 @@
 	    attr = (const pj_stun_sockaddr_attr*)ahdr;
 
-	    if (attr->sockaddr.addr.sa_family == PJ_AF_INET) {
+	    if (attr->sockaddr.addr.sa_family == pj_AF_INET()) {
 		len = pj_ansi_snprintf(p, end-p,
 				       ", IPv4 addr=%s:%d\n",
@@ -90,5 +90,5 @@
 				       pj_ntohs(attr->sockaddr.ipv4.sin_port));
 
-	    } else if (attr->sockaddr.addr.sa_family == PJ_AF_INET6) {
+	    } else if (attr->sockaddr.addr.sa_family == pj_AF_INET6()) {
 		len = pj_ansi_snprintf(p, end-p,
 				       ", IPv6 addr present\n");
Index: pjproject/trunk/pjnath/src/pjnath/stun_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1405)
@@ -563,8 +563,8 @@
     char buf[512];
     
-    if (dst->addr.sa_family == PJ_AF_INET) {
+    if (dst->addr.sa_family == pj_AF_INET()) {
 	dst_name = pj_inet_ntoa(dst->ipv4.sin_addr);
 	dst_port = pj_ntohs(dst->ipv4.sin_port);
-    } else if (dst->addr.sa_family == PJ_AF_INET6) {
+    } else if (dst->addr.sa_family == pj_AF_INET6()) {
 	dst_name = "IPv6";
 	dst_port = pj_ntohs(dst->ipv6.sin6_port);
Index: pjproject/trunk/pjnath/src/pjstun-client/client_main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjstun-client/client_main.c	(revision 1405)
@@ -271,5 +271,5 @@
     pj_assert(status == PJ_SUCCESS);
 
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &g.peer_sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &g.peer_sock);
     pj_assert(status == PJ_SUCCESS);
 
@@ -277,5 +277,5 @@
     pj_assert(status == PJ_SUCCESS);
 
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &g.sock);
+    status = pj_sock_socket(pj_AF_INET(), pj_SOCK_DGRAM(), 0, &g.sock);
     pj_assert(status == PJ_SUCCESS);
 
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/bind_usage.c	(revision 1405)
@@ -75,5 +75,5 @@
 
     status = pj_stun_usage_create(srv, "bind%p", &usage_cb,
-				  PJ_AF_INET, PJ_SOCK_DGRAM, 0,
+				  pj_AF_INET(), pj_SOCK_DGRAM(), 0,
 				  &local_addr, sizeof(local_addr),
 				  &bu->usage);
Index: pjproject/trunk/pjnath/src/pjstun-srv-test/main.c
===================================================================
--- pjproject/trunk/pjnath/src/pjstun-srv-test/main.c	(revision 1404)
+++ pjproject/trunk/pjnath/src/pjstun-srv-test/main.c	(revision 1405)
@@ -132,5 +132,5 @@
     */
 
-    status = pj_stun_turn_usage_create(srv, PJ_SOCK_DGRAM, NULL,
+    status = pj_stun_turn_usage_create(srv, pj_SOCK_DGRAM(), NULL,
 				       3478, o.use_fingerprint, &turn);
     if (status != PJ_SUCCESS) {
